| Face Engine SDK 5.31.2 A face detection, recognition and tracking engine.

Public Member Functions | List of all members
fsdk::IFaceEngine Struct Referenceabstract
SDK core interfaces

Root LUNA SDK object interface. More...

`#include <IFaceEngine.h>`

Inheritance diagram for fsdk::IFaceEngine:

## Public Member Functions
virtual ResultValue< FSDKError, IDetectorPtr > | createDetector (ObjectDetectorClassType type=FACE_DET_DEFAULT, SensorType mode=SensorType::Visible, const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates a detector of a given type. More...
virtual ResultValue< FSDKError, IHeadDetectorPtr > | createHeadDetector (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates a head detector. More...
virtual ResultValue< FSDKError, IFaceLandmarksDetectorPtr > | createFaceLandmarksDetector (SensorType mode=SensorType::Visible, const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates a face landmark detector. More...
virtual ResultValue< FSDKError, IOrientationEstimatorPtr > | createOrientationEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
virtual ResultValue< FSDKError, IHumanDetectorPtr > | createHumanDetector (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates a human detector. More...
virtual ResultValue< FSDKError, IHumanFaceDetectorPtr > | createHumanFaceDetector (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates a HumanFace detector, which detects humans, faces and associations between them. More...
virtual ResultValue< FSDKError, IHeadPoseEstimatorPtr > | createHeadPoseEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Head pose estimator. More...
virtual ResultValue< FSDKError, IOverlapEstimatorPtr > | createOverlapEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Overlap estimator. More...
virtual ResultValue< FSDKError, IAGSEstimatorPtr > | createAGSEstimator (const LaunchOptions *options=nullptr) noexcept=0
| Creates AGS estimator. More...
virtual ResultValue< FSDKError, IAttributeEstimatorPtr > | createAttributeEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Attribute estimator. More...
virtual ResultValue< FSDKError, IHumanAttributeEstimatorPtr > | createHumanAttributeEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates HumanAttribute estimator. More...
virtual ResultValue< FSDKError, IQualityEstimatorPtr > | createQualityEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Quality estimator. More...
virtual ResultValue< FSDKError, IBlackWhiteEstimatorPtr > | createBlackWhiteEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates BlackWhite estimator. More...
virtual ResultValue< FSDKError, ILivenessDepthEstimatorPtr > | createDepthEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Liveness Depth estimator. More...
virtual ResultValue< FSDKError, IDepthLivenessEstimatorPtr > | createDepthLivenessEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates universal DepthLiveness estimator. More...
virtual ResultValue< FSDKError, IImageModificationEstimatorPtr > | createImageModificationEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates image modification estimator. More...
virtual ResultValue< FSDKError, ILivenessDepthRGBEstimatorPtr > | createLivenessDepthRGBEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Liveness Depth+RGB estimator. More...
virtual ResultValue< FSDKError, ILivenessIREstimatorPtr > | createIREstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Liveness Infrared estimator. More...
virtual ResultValue< FSDKError, ILivenessOneShotRGBEstimatorPtr > | createLivenessOneShotRGBEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Liveness OneShot estimator. More...
virtual ResultValue< FSDKError, IMouthEstimatorPtr > | createMouthEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Mouth estimator. More...
virtual ResultValue< FSDKError, IMedicalMaskEstimatorPtr > | createMedicalMaskEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates MedicalMask estimator. More...
virtual ResultValue< FSDKError, ILivenessFlyingFacesEstimatorPtr > | createLivenessFlyingFacesEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates LivenessFlyingFaces estimator. More...
virtual ResultValue< FSDKError, ILivenessFPREstimatorPtr > | createLivenessFPREstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates LivenessFPR estimator. More...
virtual ResultValue< FSDKError, ILivenessRGBMEstimatorPtr > | createLivenessRGBMEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Liveness RGBM estimator. More...
virtual ResultValue< FSDKError, IEyeEstimatorPtr > | createEyeEstimator (SensorType mode=SensorType::Visible, const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Eye estimator. More...
virtual ResultValue< FSDKError, IEmotionsEstimatorPtr > | createEmotionsEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Emotions estimator. More...
virtual ResultValue< FSDKError, IGazeEstimatorPtr > | createGazeEstimator (SensorType mode=SensorType::Visible, const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Gaze estimator. More...
virtual ResultValue< FSDKError, IGlassesEstimatorPtr > | createGlassesEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Glasses estimator. More...
virtual ResultValue< FSDKError, IFaceOcclusionEstimatorPtr > | createFaceOcclusionEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates FaceOcclusion estimator. More...
virtual ResultValue< FSDKError, IBestShotQualityEstimatorPtr > | createBestShotQualityEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates BestShotQuality estimator. More...
virtual ResultValue< FSDKError, ICredibilityCheckEstimatorPtr > | createCredibilityCheckEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates CredibilityCheck estimator. More...
virtual ResultValue< FSDKError, IHeadWearEstimatorPtr > | createHeadWearEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates HeadWear estimator. More...
virtual ResultValue< FSDKError, IFacialHairEstimatorPtr > | createFacialHairEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates FacialHair estimator. More...
virtual ResultValue< FSDKError, IFishEyeEstimatorPtr > | createFishEyeEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates FishEye estimator. More...
virtual ResultValue< FSDKError, INaturalLightEstimatorPtr > | createNaturalLightEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates NaturalLight estimator. More...
virtual ResultValue< FSDKError, IPPEEstimatorPtr > | createPPEEstimator (const LaunchOptions *LaunchOptions=nullptr) noexcept=0
| Creates Personal Protection Equipment (PPE) estimator. More...
virtual ResultValue< FSDKError, IPortraitStyleEstimatorPtr > | createPortraitStyleEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates PortraitStyle estimator. More...
virtual ResultValue< FSDKError, IDynamicRangeEstimatorPtr > | createDynamicRangeEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates DynamicRange estimator. More...
virtual ResultValue< FSDKError, IBackgroundEstimatorPtr > | createBackgroundEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Background estimator. More...
virtual ResultValue< FSDKError, IRedEyeEstimatorPtr > | createRedEyeEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates Red Eye estimator. More...
virtual ResultValue< FSDKError, IEyeBrowEstimatorPtr > | createEyeBrowEstimator (const LaunchOptions *LaunchOptions=nullptr) noexcept=0
| Creates EyeBrow estimator . More...
virtual ResultValue< FSDKError, IEthnicityEstimatorPtr > | createEthnicityEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
virtual ResultValue< FSDKError, ICrowdEstimatorPtr > | createCrowdEstimator (fsdk::CrowdEstimatorType type=fsdk::CrowdEstimatorType::CET_DEFAULT, const LaunchOptions *LaunchOptions=nullptr) noexcept=0
| Creates Crowd estimator. More...
virtual ResultValue< FSDKError, experimental::IDeepFakeEstimatorPtr > | createDeepFakeEstimator (const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates DeepFake estimator. The current implementation is experimental, and does not support backward compatibility. The API can be modified in upcoming versions. More...
virtual ResultValue< FSDKError, INIRLivenessEstimatorPtr > | createNIRLivenessEstimator (const NIRLivenessMode mode=NIRLivenessMode::Default, const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates NIRLiveness estimator. More...
virtual ResultValue< FSDKError, IFightsEstimatorPtr > | createFightsEstimator (const LaunchOptions *LaunchOptions=nullptr) noexcept=0
| Creates FightsEstimator estimator. More...
virtual ResultValue< FSDKError, IDescriptorPtr > | createDescriptor (uint32_t version=0) noexcept=0
| Creates Descriptor. More...
virtual ResultValue< FSDKError, IDescriptorPtr > | createDescriptor (IArchive *archive, uint32_t flags=0) noexcept=0
| Creates and loads Descriptor from Archive. More...
virtual ResultValue< FSDKError, IDescriptorBatchPtr > | createDescriptorBatch (int32_t size, uint32_t version=0) noexcept=0
| Creates Batch of descriptors. More...
virtual ResultValue< FSDKError, IDescriptorExtractorPtr > | createExtractor (uint32_t version=0, const LaunchOptions *launchOptions=nullptr) noexcept=0
| Creates descriptor extractor. More...
virtual ResultValue< FSDKError, IDescriptorMatcherPtr > | createMatcher (uint32_t version=0) noexcept=0
| Creates descriptor matcher. More...
virtual ResultValue< FSDKError, IIndexBuilderPtr > | createIndexBuilder (const size_t capacity=0, uint32_t version=0) noexcept=0
| Creates index builder. More...
virtual ResultValue< FSDKError, IDenseIndexPtr > | loadDenseIndex (const char *indexPath) noexcept=0
| Loads dense index. More...
virtual ResultValue< FSDKError, IDynamicIndexPtr > | loadDynamicIndex (const char *indexPath) noexcept=0
| Loads dynamic index. More...
virtual ResultValue< FSDKError, IWarperPtr > | createWarper () noexcept=0
| Creates warper. More...
virtual ResultValue< FSDKError, IHumanWarperPtr > | createHumanWarper () noexcept=0
| Creates human warper. More...
virtual ResultValue< FSDKError, IImageTransferPtr > | createImageTransfer (const LaunchOptions *LaunchOptions=nullptr) noexcept=0
| Creates Image transfer facility. More...
virtual ResultValue< FSDKError, IAsyncContextPtr > | createAsyncContext (const int8_t threadCount) noexcept=0
| Creates async context. More...
virtual FaceEngineEdition | getFaceEngineEdition () const noexcept=0
| Get LUNA SDK ditribution edition. More...
virtual void | setDataDirectory (const char *path) noexcept=0
| Sets data directory. More...
virtual const char * | getDataDirectory () const noexcept=0
| Gets data directory. More...
virtual void | setSettingsProvider (ISettingsProvider *provider) noexcept=0
| Sets settings provider. More...
virtual void | setRuntimeSettingsProvider (ISettingsProvider *provider) noexcept=0
| Sets runtime settings provider. More...
virtual ISettingsProvider * | getSettingsProvider () const noexcept=0
| Gets settings provider. More...
virtual ISettingsProvider * | getRuntimeSettingsProvider () const noexcept=0
| Gets runtime settings provider. More...
virtual ILicense * | getLicense () const noexcept=0
| Get current License object, which was set for FaceEngine object. More...
Public Member Functions inherited from fsdk::IRefCounted
virtual int32_t | retain () noexcept=0
| Increase strong reference count. More...
virtual int32_t | retainLocked () noexcept=0
| Increase strong reference count thread safely. More...
virtual int32_t | release () noexcept=0
| Decrease strong reference count. More...
virtual int32_t | getRefCount () const noexcept=0
| Get actual strong reference count. More...
virtual int32_t | retainWeak () noexcept=0
| Increase weak reference count. More...
virtual int32_t | releaseWeak () noexcept=0
| Decrease weak reference count. More...
virtual int32_t | getWeakRefCount () const noexcept=0
| Get actual weak reference count. More...

## Detailed Description

Root LUNA SDK object interface.

Note
  Face Engine also implements factory interface so all usual factory options apply.

## Member Function Documentation

## ◆ createAGSEstimator()

virtual ResultValue<FSDKError, IAGSEstimatorPtr> fsdk::IFaceEngine::createAGSEstimator | ( | const LaunchOptions * | options = `nullptr` | ) |
| pure virtual noexcept

Creates AGS estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IAGSEstimatorPtr instance.

See also
  ResultValue, FSDKError, IAGSEstimatorPtr, LaunchOptions

## ◆ createAsyncContext()

virtual ResultValue<FSDKError, IAsyncContextPtr> fsdk::IFaceEngine::createAsyncContext | ( | const int8_t | threadCount | ) |
| pure virtual noexcept

Creates async context.

Parameters

  [in] | threadCount | Count of threads to create for internal thread pool.

Returns
  ResultValue with error code and IAsyncContextPtr instance.

See also
  ResultValue, FSDKError, IAsyncContextPtr

## ◆ createAttributeEstimator()

virtual ResultValue<FSDKError, IAttributeEstimatorPtr> fsdk::IFaceEngine::createAttributeEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Attribute estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IAttributeEstimatorPtr instance.

See also
  ResultValue, FSDKError, IAttributeEstimatorPtr, LaunchOptions

## ◆ createBackgroundEstimator()

virtual ResultValue<FSDKError, IBackgroundEstimatorPtr> fsdk::IFaceEngine::createBackgroundEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Background estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IBackgroundEstimator instance.

See also
  ResultValue, FSDKError, IBackgroundEstimatorPtr, LaunchOptions

## ◆ createBestShotQualityEstimator()

virtual ResultValue<FSDKError, IBestShotQualityEstimatorPtr> fsdk::IFaceEngine::createBestShotQualityEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates BestShotQuality estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IBestShotQualityEstimatorPtr instance.

See also
  ResultValue, FSDKError, IBestShotQualityEstimatorPtr, LaunchOptions

## ◆ createBlackWhiteEstimator()

virtual ResultValue<FSDKError, IBlackWhiteEstimatorPtr> fsdk::IFaceEngine::createBlackWhiteEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates BlackWhite estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IBlackWhiteEstimatorPtr instance.

See also
  ResultValue, FSDKError, IBlackWhiteEstimatorPtr, LaunchOptions

## ◆ createCredibilityCheckEstimator()

virtual ResultValue<FSDKError, ICredibilityCheckEstimatorPtr> fsdk::IFaceEngine::createCredibilityCheckEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates CredibilityCheck estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and ICredibilityCheckEstimatorPtr instance.

See also
  ResultValue, FSDKError, ICredibilityCheckEstimatorPtr, LaunchOptions

## ◆ createCrowdEstimator()

virtual ResultValue<FSDKError, ICrowdEstimatorPtr> fsdk::IFaceEngine::createCrowdEstimator | ( | fsdk::CrowdEstimatorType | type = `fsdk::CrowdEstimatorType::CET_DEFAULT`,
|  | const LaunchOptions * | LaunchOptions = `nullptr`
| ) |  |
| pure virtual noexcept

Creates Crowd estimator.

Parameters

  [in] | type | type of the Crowd estimator to create.
  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and ICrowdEstimatorPtr instance.

See also
  ResultValue, FSDKError, ICrowdEstimator, LaunchOptions

## ◆ createDeepFakeEstimator()

virtual ResultValue<FSDKError, experimental::IDeepFakeEstimatorPtr> fsdk::IFaceEngine::createDeepFakeEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates DeepFake estimator. The current implementation is experimental, and does not support backward compatibility. The API can be modified in upcoming versions.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IDeepFakeEstimatorPtr instance.

See also
  ResultValue, FSDKError, IDeepFakeEstimatorPtr, LaunchOptions

## ◆ createDepthEstimator()

virtual ResultValue<FSDKError, ILivenessDepthEstimatorPtr> fsdk::IFaceEngine::createDepthEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Liveness Depth estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and ILivenessDepthEstimatorPtr instance.

See also
  ResultValue, FSDKError, ILivenessDepthEstimatorPtr, LaunchOptions

## ◆ createDepthLivenessEstimator()

virtual ResultValue<FSDKError, IDepthLivenessEstimatorPtr> fsdk::IFaceEngine::createDepthLivenessEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates universal DepthLiveness estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IDepthLivenessEstimatorPtr instance.

See also
  ResultValue, FSDKError, IDepthLivenessEstimatorPtr, LaunchOptions

## ◆ createDescriptor() [1/2]

virtual ResultValue<FSDKError, IDescriptorPtr> fsdk::IFaceEngine::createDescriptor | ( | uint32_t | version = `0` | ) |
| pure virtual noexcept

Creates Descriptor.

Parameters

  [in] | version | descriptor version.

face descriptor will created by default, to create human descriptor pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 102

Returns
  ResultValue with error code and IDescriptorPtr instance.

See also
  ResultValue, FSDKError, IDescriptorPtr, DescriptorVersion,

## ◆ createDescriptor() [2/2]

virtual ResultValue<FSDKError, IDescriptorPtr> fsdk::IFaceEngine::createDescriptor | ( | IArchive * | archive,
|  | uint32_t | flags = `0`
| ) |  |
| pure virtual noexcept

Creates and loads Descriptor from Archive.

Parameters

  [in] | archive | Archive with descriptor.
  [in] | flags | Archive flag.

Returns
  ResultValue with error code and IDescriptorPtr instance.

See also
  ResultValue, FSDKError, IDescriptorPtr, IArchive

## ◆ createDescriptorBatch()

virtual ResultValue<FSDKError, IDescriptorBatchPtr> fsdk::IFaceEngine::createDescriptorBatch | ( | int32_t | size,
|  | uint32_t | version = `0`
| ) |  |
| pure virtual noexcept

Creates Batch of descriptors.

face descriptor batch will be created by default, to create human descriptor batch you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 102

Parameters

  [in] | size | - amount of descriptors in batch.
  [in] | version | - descriptor version in batch. If 0 - use default version from config.

Returns
  ResultValue with error code and IDescriptorBatchPtr instance.

See also
  ResultValue, FSDKError, IDescriptorBatchPtr, DescriptorVersion

## ◆ createDetector()

virtual ResultValue<FSDKError, IDetectorPtr> fsdk::IFaceEngine::createDetector | ( | ObjectDetectorClassType | type = `FACE_DET_DEFAULT`,
|  | SensorType | mode = `SensorType::Visible`,
|  | const LaunchOptions * | launchOptions = `nullptr`
| ) |  |
| pure virtual noexcept

Creates a detector of a given type.

Parameters

  [in] | type | detector type. Supported types: FACE_DET_V2, FACE_DET_V3.
  [in] | mode | camera sensor type to perform detection on.
  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IDetectorPtr instance.

See also
  ResultValue, FSDKError, IDetectorPtr, LaunchOptions, SensorType

## ◆ createDynamicRangeEstimator()

virtual ResultValue<FSDKError, IDynamicRangeEstimatorPtr> fsdk::IFaceEngine::createDynamicRangeEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates DynamicRange estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IDynamicRangeEstimator instance.

See also
  ResultValue, FSDKError, IDynamicRangeEstimatorPtr, LaunchOptions

## ◆ createEmotionsEstimator()

virtual ResultValue<FSDKError, IEmotionsEstimatorPtr> fsdk::IFaceEngine::createEmotionsEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Emotions estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IEmotionsEstimatorPtr instance.

See also
  ResultValue, FSDKError, IEmotionsEstimatorPtr, LaunchOptions

## ◆ createExtractor()

virtual ResultValue<FSDKError, IDescriptorExtractorPtr> fsdk::IFaceEngine::createExtractor | ( | uint32_t | version = `0`,
|  | const LaunchOptions * | launchOptions = `nullptr`
| ) |  |
| pure virtual noexcept

Creates descriptor extractor.

face descriptor extractor will created by default, to create human descriptor extractor descriptor you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 102

Parameters

  [in] | version | descriptor version.
  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IDescriptorExtractorPtr instance.

See also
  ResultValue, FSDKError, IDescriptorExtractorPtr, DescriptorVersion, LaunchOptions

## ◆ createEyeBrowEstimator()

virtual ResultValue<FSDKError, IEyeBrowEstimatorPtr> fsdk::IFaceEngine::createEyeBrowEstimator | ( | const LaunchOptions * | LaunchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates EyeBrow estimator .

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IEyeBrowEstimatorPtr instance.

See also
  ResultValue, FSDKError, IEyeBrowEstimatorPtr, LaunchOptions

## ◆ createEyeEstimator()

virtual ResultValue<FSDKError, IEyeEstimatorPtr> fsdk::IFaceEngine::createEyeEstimator | ( | SensorType | mode = `SensorType::Visible`,
|  | const LaunchOptions * | launchOptions = `nullptr`
| ) |  |
| pure virtual noexcept

Creates Eye estimator.

Parameters

  [in] | SensorType | mode camera sensor type.
  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IEyeEstimatorPtr instance.

See also
  ResultValue, SensorType, FSDKError, IEyeEstimatorPtr, LaunchOptions

## ◆ createFaceLandmarksDetector()

virtual ResultValue<FSDKError, IFaceLandmarksDetectorPtr> fsdk::IFaceEngine::createFaceLandmarksDetector | ( | SensorType | mode = `SensorType::Visible`,
|  | const LaunchOptions * | launchOptions = `nullptr`
| ) |  |
| pure virtual noexcept

Creates a face landmark detector.

Parameters

  [in] | mode | camera sensor type to perform detection on.
  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IFaceLandmarksDetectorPtr instance.

See also
  ResultValue, FSDKError, IFaceLandmarksDetectorPtr, LaunchOptions, SensorType

## ◆ createFaceOcclusionEstimator()

virtual ResultValue<FSDKError, IFaceOcclusionEstimatorPtr> fsdk::IFaceEngine::createFaceOcclusionEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates FaceOcclusion estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IFaceOcclusionEstimatorPtr instance.

See also
  ResultValue, FSDKError, IFaceOcclusionEstimatorPtr, LaunchOptions

## ◆ createFacialHairEstimator()

virtual ResultValue<FSDKError, IFacialHairEstimatorPtr> fsdk::IFaceEngine::createFacialHairEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates FacialHair estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IFacialHairEstimator instance.

See also
  ResultValue, FSDKError, IFacialHairEstimatorPtr, LaunchOptions

## ◆ createFightsEstimator()

virtual ResultValue<FSDKError, IFightsEstimatorPtr> fsdk::IFaceEngine::createFightsEstimator | ( | const LaunchOptions * | LaunchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates FightsEstimator estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IFightsEstimatorPtr instance.

See also
  ResultValue, FSDKError, IFightsEstimatorPtr, LaunchOptions

## ◆ createFishEyeEstimator()

virtual ResultValue<FSDKError, IFishEyeEstimatorPtr> fsdk::IFaceEngine::createFishEyeEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates FishEye estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IFishEyeEstimator instance.

See also
  ResultValue, FSDKError, IFishEyeEstimatorPtr, LaunchOptions

## ◆ createGazeEstimator()

virtual ResultValue<FSDKError, IGazeEstimatorPtr> fsdk::IFaceEngine::createGazeEstimator | ( | SensorType | mode = `SensorType::Visible`,
|  | const LaunchOptions * | launchOptions = `nullptr`
| ) |  |
| pure virtual noexcept

Creates Gaze estimator.

Parameters

  [in] | SensorType | mode camera sensor type.
  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IGazeEstimatorPtr instance.

See also
  ResultValue, SensorType, FSDKError, IGazeEstimatorPtr, LaunchOptions

## ◆ createGlassesEstimator()

virtual ResultValue<FSDKError, IGlassesEstimatorPtr> fsdk::IFaceEngine::createGlassesEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Glasses estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IGlassesEstimatorPtr instance.

See also
  ResultValue, FSDKError, IGlassesEstimatorPtr, LaunchOptions

## ◆ createHeadDetector()

virtual ResultValue<FSDKError, IHeadDetectorPtr> fsdk::IFaceEngine::createHeadDetector | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates a head detector.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IHeadDetectorPtr instance.

See also
  ResultValue, FSDKError, IHeadDetectorPtr, LaunchOptions, SensorType

## ◆ createHeadPoseEstimator()

virtual ResultValue<FSDKError, IHeadPoseEstimatorPtr> fsdk::IFaceEngine::createHeadPoseEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Head pose estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IHeadPoseEstimatorPtr instance.

See also
  ResultValue, FSDKError, IHeadPoseEstimatorPtr, LaunchOptions

## ◆ createHeadWearEstimator()

virtual ResultValue<FSDKError, IHeadWearEstimatorPtr> fsdk::IFaceEngine::createHeadWearEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates HeadWear estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IHeadWearEstimatorPtr instance.

See also
  ResultValue, FSDKError, IHeadWearEstimatorPtr, LaunchOptions

## ◆ createHumanAttributeEstimator()

virtual ResultValue<FSDKError, IHumanAttributeEstimatorPtr> fsdk::IFaceEngine::createHumanAttributeEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates HumanAttribute estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IHumanAttributeEstimatorPtr instance.

See also
  ResultValue, FSDKError, IHumanAttributeEstimatorPtr, LaunchOptions

## ◆ createHumanDetector()

virtual ResultValue<FSDKError, IHumanDetectorPtr> fsdk::IFaceEngine::createHumanDetector | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates a human detector.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IHumanDetectorPtr instance.

See also
  ResultValue, FSDKError, IHumanDetectorPtr, LaunchOptions

## ◆ createHumanFaceDetector()

virtual ResultValue<FSDKError, IHumanFaceDetectorPtr> fsdk::IFaceEngine::createHumanFaceDetector | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates a HumanFace detector, which detects humans, faces and associations between them.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IHumanFaceDetectorPtr instance.

See also
  ResultValue, FSDKError, IHumanFaceDetectorPtr, LaunchOptions

## ◆ createHumanWarper()

virtual ResultValue<FSDKError, IHumanWarperPtr> fsdk::IFaceEngine::createHumanWarper | ( |  | ) |
| pure virtual noexcept

Creates human warper.

Returns
  ResultValue with error code and IHumanWarperPtr instance.

See also
  ResultValue, FSDKError, IHumanWarperPtr

## ◆ createImageModificationEstimator()

virtual ResultValue<FSDKError, IImageModificationEstimatorPtr> fsdk::IFaceEngine::createImageModificationEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates image modification estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IImageModificationEstimatorPtr instance.

See also
  ResultValue, FSDKError, IImageModificationEstimatorPtr, LaunchOptions

## ◆ createImageTransfer()

virtual ResultValue<FSDKError, IImageTransferPtr> fsdk::IFaceEngine::createImageTransfer | ( | const LaunchOptions * | LaunchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Image transfer facility.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IImageTransferPtr instance.

See also
  ResultValue, FSDKError, IImageTransferPtr, LaunchOptions

## ◆ createIndexBuilder()

virtual ResultValue<FSDKError, IIndexBuilderPtr> fsdk::IFaceEngine::createIndexBuilder | ( | const size_t | capacity = `0`,
|  | uint32_t | version = `0`
| ) |  |
| pure virtual noexcept

Creates index builder.

Parameters

  [in] | capacity | - Allocate space for this number of descriptors.
  [in] | version | - Descriptor version in batch. If 0 - use default version from config.

Returns
  ResultValue with error code and IIndexBuilderPtr instance.

See also
  ResultValue, FSDKError, IIndexBuilderPtr, DescriptorVersion

## ◆ createIREstimator()

virtual ResultValue<FSDKError, ILivenessIREstimatorPtr> fsdk::IFaceEngine::createIREstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Liveness Infrared estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and ILivenessIREstimatorPtr instance.

See also
  ResultValue, FSDKError, ILivenessIREstimatorPtr, LaunchOptions

## ◆ createLivenessDepthRGBEstimator()

virtual ResultValue<FSDKError, ILivenessDepthRGBEstimatorPtr> fsdk::IFaceEngine::createLivenessDepthRGBEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Liveness Depth+RGB estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and ILivenessDepthRGBEstimatorPtr instance.

See also
  ResultValue, FSDKError, ILivenessDepthRGBEstimatorPtr, LaunchOptions

## ◆ createLivenessFlyingFacesEstimator()

virtual ResultValue<FSDKError, ILivenessFlyingFacesEstimatorPtr> fsdk::IFaceEngine::createLivenessFlyingFacesEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates LivenessFlyingFaces estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and ILivenessFlyingFacesEstimatorPtr instance.

See also
  ResultValue, FSDKError, ILivenessFlyingFacesEstimatorPtr, LaunchOptions

## ◆ createLivenessFPREstimator()

virtual ResultValue<FSDKError, ILivenessFPREstimatorPtr> fsdk::IFaceEngine::createLivenessFPREstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates LivenessFPR estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and ILivenessFPREstimatorPtr instance.

See also
  ResultValue, FSDKError, ILivenessFPREstimatorPtr, LaunchOptions

## ◆ createLivenessOneShotRGBEstimator()

virtual ResultValue<FSDKError, ILivenessOneShotRGBEstimatorPtr> fsdk::IFaceEngine::createLivenessOneShotRGBEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Liveness OneShot estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  Oneshot liveness estimator if succeed, nullptr if failed.

See also
  ResultValue, FSDKError, ILivenessOneShotRGBEstimatorPtr, LaunchOptions

## ◆ createLivenessRGBMEstimator()

virtual ResultValue<FSDKError, ILivenessRGBMEstimatorPtr> fsdk::IFaceEngine::createLivenessRGBMEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Liveness RGBM estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and ILivenessRGBMEstimatorPtr instance.

See also
  ResultValue, FSDKError, ILivenessRGBMEstimatorPtr, LaunchOptions

Note
  This estimator is required only for liveness detection purposes.

## ◆ createMatcher()

virtual ResultValue<FSDKError, IDescriptorMatcherPtr> fsdk::IFaceEngine::createMatcher | ( | uint32_t | version = `0` | ) |
| pure virtual noexcept

Creates descriptor matcher.

Parameters

  [in] | version | descriptor version.

face descriptor matcher will created by default, to create human descriptor matcher you must pass version, minimum version of human descriptor is DV_MIN_HUMAN_DESCRIPTOR_VERSION == 102

See also
  DescriptorVersion

Returns
  ResultValue with error code and IDescriptorMatcherPtr instance.

See also
  ResultValue, FSDKError, IDescriptorMatcherPtr

## ◆ createMedicalMaskEstimator()

virtual ResultValue<FSDKError, IMedicalMaskEstimatorPtr> fsdk::IFaceEngine::createMedicalMaskEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates MedicalMask estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IMedicalMaskEstimatorPtr instance.

See also
  ResultValue, FSDKError, IMedicalMaskEstimatorPtr, LaunchOptions

## ◆ createMouthEstimator()

virtual ResultValue<FSDKError, IMouthEstimatorPtr> fsdk::IFaceEngine::createMouthEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Mouth estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IMouthEstimatorPtr instance.

See also
  ResultValue, FSDKError, IMouthEstimatorPtr, LaunchOptions

## ◆ createNaturalLightEstimator()

virtual ResultValue<FSDKError, INaturalLightEstimatorPtr> fsdk::IFaceEngine::createNaturalLightEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates NaturalLight estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and INaturalLightEstimator instance.

See also
  ResultValue, FSDKError, INaturalLightEstimatorPtr, LaunchOptions

## ◆ createNIRLivenessEstimator()

virtual ResultValue<FSDKError, INIRLivenessEstimatorPtr> fsdk::IFaceEngine::createNIRLivenessEstimator | ( | const NIRLivenessMode | mode = `NIRLivenessMode::Default`,
|  | const LaunchOptions * | launchOptions = `nullptr`
| ) |  |
| pure virtual noexcept

Creates NIRLiveness estimator.

Parameters

  [in] | mode | is the option to set estimation scenario.

See also
  NIRLivenessMode.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and INIRLivenessEstimatorPtr instance.

See also
  ResultValue, FSDKError, INIRLivenessEstimatorPtr, LaunchOptions

## ◆ createOverlapEstimator()

virtual ResultValue<FSDKError, IOverlapEstimatorPtr> fsdk::IFaceEngine::createOverlapEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Overlap estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IOverlapEstimatorPtr instance.

See also
  ResultValue, FSDKError, IOverlapEstimatorPtr, LaunchOptions

## ◆ createPortraitStyleEstimator()

virtual ResultValue<FSDKError, IPortraitStyleEstimatorPtr> fsdk::IFaceEngine::createPortraitStyleEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates PortraitStyle estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IPortraitStyleEstimator instance.

See also
  ResultValue, FSDKError, IPortraitStyleEstimatorPtr, LaunchOptions

## ◆ createPPEEstimator()

virtual ResultValue<FSDKError, IPPEEstimatorPtr> fsdk::IFaceEngine::createPPEEstimator | ( | const LaunchOptions * | LaunchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Personal Protection Equipment (PPE) estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IPPEEstimatorPtr instance.

See also
  ResultValue, FSDKError, IPPEEstimatorPtr, LaunchOptions

## ◆ createQualityEstimator()

virtual ResultValue<FSDKError, IQualityEstimatorPtr> fsdk::IFaceEngine::createQualityEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Quality estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IQualityEstimatorPtr instance.

See also
  ResultValue, FSDKError, IQualityEstimatorPtr, LaunchOptions

## ◆ createRedEyeEstimator()

virtual ResultValue<FSDKError, IRedEyeEstimatorPtr> fsdk::IFaceEngine::createRedEyeEstimator | ( | const LaunchOptions * | launchOptions = `nullptr` | ) |
| pure virtual noexcept

Creates Red Eye estimator.

Parameters

  [in] | launchOptions | launch options for fine grained control over target device resources.

Returns
  ResultValue with error code and IRedEyeEstimatorPtr instance.

See also
  ResultValue, FSDKError, IRedEyeEstimatorPtr, LaunchOptions

## ◆ createWarper()

virtual ResultValue<FSDKError, IWarperPtr> fsdk::IFaceEngine::createWarper | ( |  | ) |
| pure virtual noexcept

Creates warper.

Returns
  ResultValue with error code and IWarperPtr instance.

See also
  ResultValue, FSDKError, IWarperPtr

## ◆ getDataDirectory()

virtual const char* fsdk::IFaceEngine::getDataDirectory | ( |  | ) | const
| pure virtual noexcept

Gets data directory.

By default is set to "./data".

Returns
  path to data directory.

## ◆ getFaceEngineEdition()

virtual FaceEngineEdition fsdk::IFaceEngine::getFaceEngineEdition | ( |  | ) | const
| pure virtual noexcept

Get LUNA SDK ditribution edition.

Returns
  Edition of LUNA SDK instance. Posible values:
  - CompleteEdition - full edition with all function.
  - FrontEndEdition - short edition with excluded descriptor functions. Extractor, matcher, descriptor, batch and index cannot be created.

## ◆ getLicense()

virtual ILicense* fsdk::IFaceEngine::getLicense | ( |  | ) | const
| pure virtual noexcept

Get current License object, which was set for FaceEngine object.

Returns
  pointer to current license object, nullptr if no any license was set to.

## ◆ getRuntimeSettingsProvider()

virtual ISettingsProvider* fsdk::IFaceEngine::getRuntimeSettingsProvider | ( |  | ) | const
| pure virtual noexcept

Gets runtime settings provider.

Returns
  runtime settings provider.

## ◆ getSettingsProvider()

virtual ISettingsProvider* fsdk::IFaceEngine::getSettingsProvider | ( |  | ) | const
| pure virtual noexcept

Gets settings provider.

Returns
  settings provider.

## ◆ loadDenseIndex()

virtual ResultValue<FSDKError, IDenseIndexPtr> fsdk::IFaceEngine::loadDenseIndex | ( | const char * | indexPath | ) |
| pure virtual noexcept

Loads dense index.

Note
  Only indexes saved as dense are to be loaded as dense.

Parameters

  [in] | indexPath | Path to index to be loaded.

Returns
  ResultValue with error code and IDenseIndexPtr instance.

See also
  ResultValue, FSDKError, IDenseIndexPtr

## ◆ loadDynamicIndex()

virtual ResultValue<FSDKError, IDynamicIndexPtr> fsdk::IFaceEngine::loadDynamicIndex | ( | const char * | indexPath | ) |
| pure virtual noexcept

Loads dynamic index.

Note
  Only indexes saved as dynamic are to be loaded as dynamic.

Parameters

  [in] | indexPath | Path to index to be loaded.

Returns
  ResultValue with error code and IDynamicIndexPtr instance.

See also
  ResultValue, FSDKError, IDynamicIndexPtr

## ◆ setDataDirectory()

virtual void fsdk::IFaceEngine::setDataDirectory | ( | const char * | path | ) |
| pure virtual noexcept

Sets data directory.

Parameters

  [in] | path | path to data directory.

## ◆ setRuntimeSettingsProvider()

virtual void fsdk::IFaceEngine::setRuntimeSettingsProvider | ( | ISettingsProvider * | provider | ) |
| pure virtual noexcept

Sets runtime settings provider.

Parameters

  [in] | provider | runtime settings provider.

## ◆ setSettingsProvider()

virtual void fsdk::IFaceEngine::setSettingsProvider | ( | ISettingsProvider * | provider | ) |
| pure virtual noexcept

Sets settings provider.

Parameters

  [in] | provider | settings provider.

The documentation for this struct was generated from the following file:

- include/fsdk/IFaceEngine.h